# HARDWARE DESIGN PROCESS

*The hardware design processes produce a hardware item that fulfills the requirements allocated to hardware from the system requirements. These are Requirements Capture, Conceptual Design, Detailed Design, Implementation and Production Transition. These design processes may be applied at any hierarchical level of the hardware item, such as LRUs, circuit board assemblies and ASICs/PLDs. The following sections describe each process, its objectives and the related activities that should be addressed to reduce the probability of design and implementation errors that affect safety. It is important that each of these processes is planned and the details recorded in a hardware design plan.*

| Data Required for the Hardware Development Review    |
|:-----------------------------------------------------|
| Hardware Requirements, Design and HDL Code Standards |
| Hardware Requirements                                |
| Hardware Design Data                                 |
| Hardware Description Language                        |
| Hardware Design Schematics                           |
| Hardware Traceability Data                           |
| Hardware Review and Analysis Procedures              |
| Hardware Review and Analysis Results                 |
| Hardware Life Cycle Environment Configuration Index  |
| Problem Reports                                      |
| Hardware Configuration Management Records            |
| Hardware Process Assurance Records                   |
| Hardware Tool Qualification Data                     |
:Data Required for the Hardware Development Review

.. ....... ........ ........ ....... .. ........... ...... .... .. ...... ..... .. ..... .... ........ ... ...... . ... .... .. ......... ........... .... .... ........ .. .... . ..... ....... .... ... ........ .... ............ .. ... ... ....... .. ...... .... ... .... ....... .. ..... ... .... ....... ... ....... ......... ..... .......... ....... ..... ....... ... ....... ... ....... ..... ..... .... . ........ .. ... ..... ......... .. ........ ..... ....... .......... .......... ... ........ .. ... ..... .. ........ ..... .......... .... ... ...... .. .....

## Requirements Capture Process

*The requirements capture process identifies and records the hardware item requirements. This includes those derived requirements imposed by the proposed hardware item architecture, choice of technology, the basic and optional functionality, environmental, and performance requirements as well as the requirements imposed by the system safety assessment. This process may be iterative since additional requirements may become known during design.*

## Conceptual Design Process

*The conceptual design process produces a high-level design concept that may be assessed to determine the potential for the resulting design implementation to meet the requirements. This may be accomplished using such items as functional block diagrams, design and architecture descriptions, circuit card assembly outlines, and chassis sketches.*

## Detailed Design Process

*The detailed design process produces detailed design data using the hardware item requirements and conceptual design data as the basis for the detailed design.*

## Implementation Process

*The implementation process uses the detailed design data to produce the hardware item
that is an input to the testing activity.*

## Production Transition

*In this process, manufacturing data, test facilities and general resources should be examined to ensure availa bility and suitability for production. The production transition process uses the outputs from the implementation and verification processes to move the product into production.*

## Acceptance Test

*An acceptance test demonstrates that the manufactured, modified or repaired product performs in compliance with the key attributes of the unit on which certification is based. These key attributes are chosen using engineering judgement and are indicative that the product is capable of meeting the requirements to which the unit was developed.*

## Series Production

*This process is not within the scope of this document, but elements impacting design assurance are briefly described to complete the life cycle.*

*This process reproduces the hardware item on a routine basis that complies with the production data and requirements.*
